JSB.newAddon = function (mainPath) {
  JSB.require('utils')
  if (!ocrUtils.checkMNUtilsFolder(mainPath)) {
    Application.sharedInstance().showHUD("MN OCR: Please install 'MN Utils' first!",Application.sharedInstance().focusWindow,5)
    return undefined
  }
  JSB.require('webviewController');
  // Application.sharedInstance().showHUD(ocrUtils.getExtensionFolder(mainPath),Application.sharedInstance().focusWindow,5)

  var MNOCRClass = JSB.defineClass(
    'MNOCR : JSExtension',
    { /* Instance members */
      sceneWillConnect: function () { //Window initialize
        if (typeof MNUtil === 'undefined') {
          Application.sharedInstance().showHUD("MN OCR: Please install 'MN Utils' first!",Application.sharedInstance().focusWindow,5)
          return
        }
        ocrUtils.init()
        ocrUtils.mainPath = mainPath
        ocrConfig.init()
        self.isFirst = true
      },

      sceneDidDisconnect: function () { // Window disconnect

      },

      sceneWillResignActive: function () { // Window resign active
      },

      sceneDidBecomeActive: function () { // Window become active
      },

      notebookWillOpen: function (notebookid) {
        if (typeof MNUtil === 'undefined') return
        ocrUtils.checkOCRController()
        // if (ocrUtils.studyController.studyMode = 3) return
      try {
        if (ocrUtils.studyController.studyMode < 3) {
          ocrUtils.ocrController.view.hidden = true;
          ocrUtils.ocrController.notebookid = notebookid
          self.notebookid = notebookid
          ocrUtils.ocrController.view.frame = { x: 50, y: 100, width: 260, height: 305 }
          ocrUtils.ocrController.currentFrame = { x: 50, y: 100, width: 260, height: 305 }
          NSTimer.scheduledTimerWithTimeInterval(0.2, false, function () {
            ocrUtils.studyView().becomeFirstResponder(); //For dismiss keyboard on iOS
          });
        }else{
          if (ocrUtils.ocrController) {
            ocrUtils.ocrController.view.hidden = true
          }
        }
      } catch (error) {
        ocrUtils.showHUD(error)
      }
      },

      notebookWillClose: function (notebookid) {
      },

      documentDidOpen: function (docmd5) {
      },

      documentWillClose: function (docmd5) {
      },

      controllerWillLayoutSubviews: function (controller) {
        if (typeof MNUtil === 'undefined') return
        if (controller !== ocrUtils.studyController) {
          return;
        };
        if (ocrUtils.studyController.studyMode === 3 && ocrUtils.ocrController){
            ocrUtils.ocrController.view.hidden = true
        }
        if (!ocrUtils.ocrController.view.hidden) {
          let studyFrame = ocrUtils.studyView.bounds
          let currentFrame = ocrUtils.ocrController.currentFrame
          if (currentFrame.x+currentFrame.width*0.5 >= studyFrame.width) {
            currentFrame.x = studyFrame.width-currentFrame.width*0.5              
          }
          if (currentFrame.y >= studyFrame.height) {
            currentFrame.y = studyFrame.height-20              
          }
          ocrUtils.setFrame(ocrUtils.ocrController, currentFrame)
        }
      },
      queryAddonCommandStatus: function () {
        if (typeof MNUtil === 'undefined') return null
        if (ocrUtils.studyController.studyMode < 3) {
          return {
            image: 'logo.png',
            object: self,
            selector: 'toggleAddon:',
            checked: false
          };
        } else {
          if (ocrUtils.ocrController) {
            ocrUtils.ocrController.view.hidden = true
          }
          return null;
        }
      },
      toggleAddon:function (sender) {
      if (typeof MNUtil === 'undefined') return null
      try {
        

        if (!self.addonBar) {
          self.addonBar = sender.superview.superview
          ocrUtils.addonBar = self.addonBar
        }
        if (self.isFirst) {
          let buttonFrame = self.addonBar.frame
          let frame = buttonFrame.x < 100 ? {x:40,y:buttonFrame.y,width:260,height:305} : {x:buttonFrame.x-260,y:buttonFrame.y,width:260,height:305}
          ocrUtils.setFrame(ocrUtils.ocrController, frame)
          self.isFirst = false;
        }
        if (ocrUtils.ocrController.view.hidden) {
          ocrUtils.ocrController.show(self.addonBar.frame)
        }else{
          ocrUtils.ocrController.hide(self.addonBar.frame)
        }
      } catch (error) {
        ocrUtils.showHUD(error)
      }
      // ocrUtils.ocrController.view.hidden = !ocrUtils.ocrController.view.hidden
      }
    },
    { /* Class members */
      addonDidConnect: function () {
      },

      addonWillDisconnect: function () {
        // NSUserDefaults.standardUserDefaults().removeObjectForKey("MNOCR")
      },

      applicationWillEnterForeground: function () {
      },

      applicationDidEnterBackground: function () {
      },

      applicationDidReceiveLocalNotification: function (notify) {
      }
    }
  );
  return MNOCRClass;
};