
var ocrController = JSB.defineClass('ocrController : UIViewController <NSURLConnectionDelegate>', {
  viewDidLoad: function() {
    try {
    self.closeImage = ocrUtils.getImage(ocrUtils.mainPath + `/stop.png`, 2)
    self.settingImage = ocrUtils.getImage(ocrUtils.mainPath + `/setting.png`, 1.8)
    self.lastFrame = self.view.frame;
    self.currentFrame = self.view.frame
    self.moveDate = Date.now()
    self.view.layer.shadowOffset = {width: 0, height: 0};
    self.view.layer.shadowRadius = 15;
    self.view.layer.shadowOpacity = 0.5;
    self.view.layer.shadowColor = UIColor.colorWithWhiteAlpha(0.5, 1);
    self.view.layer.opacity = 1.0
    self.view.layer.cornerRadius = 15
    self.view.backgroundColor = UIColor.whiteColor().colorWithAlphaComponent(0.8)
    self.highlightColor = UIColor.blendedColor(ocrUtils.hexColorAlpha("#2c4d81", 0.8),
      Application.sharedInstance().defaultTextColor,
      0.8
    );

// >>> opacity button >>>
    // self.webAppButton.titleLabel.font = UIFont.systemFontOfSize(12);
    // <<< opacity button <<<
    self.ocrView = self.createView()
    self.ocrView.hidden = false
    self.ocrView.layer.backgroundColor = MNUtil.hexColorAlpha("#ffffff",0.0)

    // <<< search button <<<
    // >>> move button >>>
    self.moveButton = self.createButton("changeSource:")
    self.moveButton.titleLabel.font = UIFont.boldSystemFontOfSize(16);
    self.moveButton.backgroundColor = MNUtil.hexColorAlpha("#457bd3",0.8)


    self.closeButton = self.createButton("closeButtonTapped:")
    MNButton.setImage(self.closeButton, self.closeImage)
    MNButton.setColor(self.closeButton, "#e06c75",0.8)

    self.settingButton = self.createButton("settingButtonTapped:")
    MNButton.setImage(self.settingButton, self.settingImage)
    MNButton.setColor(self.settingButton, "#89a6d5",0.8)
    self.settingButton.open = false

    self.OCRButton = self.createButton("beginOCR:","ocrView")
    self.OCRButton.action = "toComment"
    MNButton.setTitle(self.OCRButton, "OCR → Comment",14,true)
    MNButton.setColor(self.OCRButton, "#457bd3",0.8)

    self.PDFOCRFileButton = self.createButton("beginPDFOCR:","ocrView")
    self.PDFOCRFileButton.mode = "file"
    MNButton.setTitle(self.PDFOCRFileButton, "OCR → File",14,true)
    MNButton.setColor(self.PDFOCRFileButton, "#457bd3",0.8)

    self.PDFOCRExportButton = self.createButton("beginPDFOCR:","ocrView")
    self.PDFOCRExportButton.mode = "export"
    MNButton.setTitle(self.PDFOCRExportButton, "OCR → Export",14,true)
    MNButton.setColor(self.PDFOCRExportButton, "#457bd3",0.8)

    self.PDFOCRCopyButton = self.createButton("beginPDFOCR:","ocrView")
    self.PDFOCRCopyButton.mode = "copy"
    MNButton.setTitle(self.PDFOCRCopyButton, "OCR → Clipboard",14,true)
    MNButton.setColor(self.PDFOCRCopyButton, "#457bd3",0.8)

    self.OCRCopyButton = self.createButton("beginOCR:","ocrView")
    self.OCRCopyButton.action = "copy"
    MNButton.setTitle(self.OCRCopyButton, "OCR → Clipboard",14,true)
    MNButton.setColor(self.OCRCopyButton, "#457bd3",0.8)

    self.OCRExcerptButton = self.createButton("beginOCR:","ocrView")
    self.OCRExcerptButton.action = "toExcerpt"
    MNButton.setTitle(self.OCRExcerptButton, "OCR → Excerpt",14,true)
    MNButton.setColor(self.OCRExcerptButton, "#457bd3",0.8)

    self.imageCorrectionButton = self.createButton("toggleIC:","ocrView")
    self.imageCorrectionButton.titleLabel.font = UIFont.boldSystemFontOfSize(14);

    self.equationButton = self.createButton("togglePE:","ocrView")
    self.equationButton.titleLabel.font = UIFont.boldSystemFontOfSize(14);

    self.rotationButton = self.createButton("toggleRotation:","ocrView")
    MNButton.setColor(self.rotationButton, "#457bd3",0.8)
    self.rotationButton.titleLabel.font = UIFont.boldSystemFontOfSize(14);

    self.PDFOCRButton = self.createButton("togglePDFOCR:","ocrView")
    MNButton.setColor(self.PDFOCRButton, "#457bd3",0.8)
    self.PDFOCRButton.titleLabel.font = UIFont.boldSystemFontOfSize(14);


    // self.tabButton      = UIButton.buttonWithType(0);
    self.color = ["#ffffb4","#ccfdc4","#b4d1fb","#f3aebe","#ffff54","#75fb4c","#55bbf9","#ea3323","#ef8733","#377e47","#173dac","#be3223","#ffffff","#dadada","#b4b4b4","#bd9fdc"]

        // >>> screen button >>>
    self.moveGesture3 = new UIPanGestureRecognizer(self,"onMoveGesture:")
    self.closeButton.addGestureRecognizer(self.moveGesture3)
    self.moveGesture3.view.hidden = false
    // self.moveGesture3.addTargetAction(self,"onMoveGesture:")

    self.moveGesture2 = new UIPanGestureRecognizer(self,"onMoveGesture:")
    self.settingButton.addGestureRecognizer(self.moveGesture2)
    self.moveGesture2.view.hidden = false

    self.moveGesture = new UIPanGestureRecognizer(self,"onMoveGesture:")
    self.moveButton.addGestureRecognizer(self.moveGesture)
    self.moveGesture.view.hidden = false
    // self.moveGesture.addTargetAction(self,"onMoveGesture:")
    // ocrUtils.showHUD("init")

    self.settingView = self.createView()
    self.settingView.hidden = true
    self.settingView.layer.backgroundColor = MNUtil.hexColorAlpha("#ffffff",0)



    self.apikeyInput = self.creatTextView("settingView",undefined,0.75)
    self.apikeyInput.text = ocrConfig.getConfig("doc2xApikey")
    self.apikeyInput.editable = false

    self.pasteKeyButton = self.createButton("pasteApikey:","settingView")
    MNButton.setTitle(self.pasteKeyButton,"Paste", 14,true)
    MNButton.setColor(self.pasteKeyButton, "#89a6d5")
    MNButton.setRadius(self.pasteKeyButton,8)

    self.clearButton = self.createButton("clearApikey:","settingView")
    MNButton.setTitle(self.clearButton,"Clear", 14,true)
    MNButton.setColor(self.clearButton, "#89a6d5")
    MNButton.setRadius(self.clearButton,8)

    self.refreshButton = self.createButton("refresh:","settingView")
    MNButton.setTitle(self.refreshButton,"Refresh", 14,true)
    MNButton.setColor(self.refreshButton, "#89a6d5")
    MNButton.setRadius(self.refreshButton,8)

    self.refreshView(ocrConfig.getConfig("source"))
    } catch (error) {
      ocrUtils.showHUD("Error in viewDidLoad: "+error)  
    }
  },
  viewWillAppear: function(animated) {
  },
  viewWillDisappear: function(animated) {
  },
viewWillLayoutSubviews: function() {
    var viewFrame = self.view.bounds;
    var xLeft     = viewFrame.x
    var xRight    = xLeft + viewFrame.width
    var yTop      = viewFrame.y
    var yBottom   = yTop + viewFrame.height
    self.settingView.frame = MNUtil.genFrame(0, 40, viewFrame.width, viewFrame.height-45)
    self.ocrView.frame = MNUtil.genFrame(0, 40, viewFrame.width, viewFrame.height-45)
    
    self.moveButton.frame = {x: xLeft+10 ,y: 10,width: 170,height: 30};
    self.settingButton.frame = {x: xLeft+185,y: 10,width: 30,height: 30};
    self.closeButton.frame = {x: xLeft+220,y: 10,width: 30,height: 30};

    self.OCRButton.frame = {x: xLeft+10 ,y: 10,width: 240,height: 30};
    self.PDFOCRFileButton.frame = {x: xLeft+10 ,y: 10,width: 240,height: 30};
    self.OCRCopyButton.frame = {x: xLeft+10 ,y: 45,width: 240,height: 30};
    self.PDFOCRCopyButton.frame = {x: xLeft+10 ,y: 45,width: 240,height: 30};
    self.PDFOCRExportButton.frame = {x: xLeft+10 ,y: 80,width: 240,height: 30};
    self.OCRExcerptButton.frame = {x: xLeft+10 ,y: 80,width: 240,height: 30};
    self.imageCorrectionButton.frame = {x: xLeft+10 ,y: 115,width: 240,height: 30};
    self.rotationButton.frame = {x: xLeft+10 ,y: 115,width: 240,height: 30};
    self.PDFOCRButton.frame = {x: xLeft+10 ,y: 115,width: 240,height: 30};
    self.equationButton.frame = {x: xLeft+10 ,y: 150,width: 240,height: 30};

    self.pasteKeyButton.frame = {x: viewFrame.width - 65 ,y: 50,width: 50,height: 25};
    self.clearButton.frame = {x: viewFrame.width - 120 ,y: 50,width: 50,height: 25};
    self.refreshButton.frame = {x: viewFrame.width - 195 ,y: 50,width: 70,height: 25};
    self.apikeyInput.frame = {x: xLeft+10 ,y: 10,width: 240,height: 70};
  },
  scrollViewDidScroll: function() {
  },
  changeSource:function (sender) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    let commandTable = [
      {title:'Doc2X Image',object:self,selector:'changeSourceTo:',param:"Doc2X",checked:ocrConfig.config.source === "Doc2X"},
      {title:'SimpleTex',object:self,selector:'changeSourceTo:',param:"SimpleTex",checked:ocrConfig.config.source === "SimpleTex"}
    ];
    self.view.popoverController = ocrUtils.getPopoverAndPresent(sender,commandTable,200)
    // self.view.popoverController = ocrUtils.getPopoverAndPresent(sender,commandTable,200)
  },
  changeSourceTo:function (source) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    ocrConfig.config.source = source
    self.refreshView(source)
    ocrConfig.save()
  },
  pasteApikey: async function (params) {
    let apikey = ocrUtils.clipboardText().trim()
    self.apikeyInput.text = apikey
    switch (ocrConfig.getConfig("source")) {
      case "Doc2X":
        ocrConfig.config.doc2xApikey = apikey
        ocrNetwork.accessToken = await ocrNetwork.getAccessToken(apikey)
        break;
      case "SimpleTex":
        ocrConfig.config.simpleTexApikey = apikey
        break;
      default:
        break;
    }
    ocrConfig.save()
  },
  clearApikey:function (params) {
    self.apikeyInput.text = ""
    switch (ocrConfig.getConfig("source")) {
      case "Doc2X":
        ocrConfig.config.doc2xApikey = ""
        break;
      case "SimpleTex":
        ocrConfig.config.simpleTexApikey = ""
        break;
      default:
        break;
    }
    ocrConfig.save()
  },
  refresh: async function () {
    ocrNetwork.accessToken = await ocrNetwork.refreshAccessToken(ocrConfig.getConfig("doc2xApikey").trim())
  },
  toggleIC: function (params) {
    ocrConfig.config.imageCorrection = !ocrConfig.getConfig("imageCorrection")
    self.imageCorrectionButton.setTitleForState("Image Correction: "+(ocrConfig.config.imageCorrection?"✅":"❌"),0)
    self.imageCorrectionButton.backgroundColor = ocrUtils.hexColorAlpha(ocrConfig.config.imageCorrection?"#457bd3":"#9bb2d6",0.8)

    ocrConfig.save()
  },
  togglePE: function (sender) {
    switch (ocrConfig.config.source) {
      case "SimpleTex":
        if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
        let commandTable = [
          {title:'auto',object:self,selector:'changeRecModeTo:',param:"auto",checked:ocrConfig.getConfig("simpleTexRecMode") === "auto"},
          {title:'document',object:self,selector:'changeRecModeTo:',param:"document",checked:ocrConfig.getConfig("simpleTexRecMode") === "document"},
          {title:'formula',object:self,selector:'changeRecModeTo:',param:"formula",checked:ocrConfig.getConfig("simpleTexRecMode") === "formula"}
        ];
        self.view.popoverController = MNUtil.getPopoverAndPresent(sender,commandTable,200)
        // ocrConfig.config.simpleTexGeneral = !ocrConfig.getConfig("simpleTexGeneral")
        // self.equationButton.setTitleForState("Pure Equation: "+(ocrConfig.config.simpleTexGeneral?"❌":"✅"),0)
        // self.equationButton.backgroundColor = ocrUtils.hexColorAlpha(ocrConfig.config.simpleTexGeneral?"#9bb2d6":"#457bd3",0.8)
        break;
      case "Doc2X":
        ocrConfig.config.pureEquation = !ocrConfig.getConfig("pureEquation")
        self.equationButton.setTitleForState("Pure Equation: "+(ocrConfig.config.pureEquation?"✅":"❌"),0)
        self.equationButton.backgroundColor = ocrUtils.hexColorAlpha(ocrConfig.config.pureEquation?"#457bd3":"#9bb2d6",0.8)
        break;
      default:
        break;
    }
    ocrConfig.save()
  },
  changeRecModeTo: function (param) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    ocrConfig.config.simpleTexRecMode = param
    self.equationButton.setTitleForState("Rec mode: "+param,0)
  },
  toggleRotation: function (params) {
    ocrConfig.config.simpleTexRotation = !ocrConfig.getConfig("simpleTexRotation")
    self.rotationButton.setTitleForState("Image Rotation: "+(ocrConfig.config.simpleTexRotation?"✅":"❌"),0)
    self.rotationButton.backgroundColor = ocrUtils.hexColorAlpha(ocrConfig.config.simpleTexRotation?"#457bd3":"#9bb2d6",0.8)
    ocrConfig.save()

    // ocrConfig.config.simpleTexTurbo = !ocrConfig.getConfig("simpleTexTurbo")
    // self.rotationButton.setTitleForState("Turbo: "+(ocrConfig.config.simpleTexTurbo?"✅":"❌"),0)
    // self.rotationButton.backgroundColor = ocrUtils.hexColorAlpha(ocrConfig.config.simpleTexTurbo?"#457bd3":"#9bb2d6",0.8)
    // ocrConfig.save()
  },
  togglePDFOCR: function (params) {
    ocrConfig.config.PDFOCR = !ocrConfig.getConfig("PDFOCR")
    self.PDFOCRButton.setTitleForState("PDF OCR: "+(ocrConfig.config.PDFOCR?"✅":"❌"),0)
    self.PDFOCRButton.backgroundColor = ocrUtils.hexColorAlpha(ocrConfig.config.PDFOCR?"#457bd3":"#9bb2d6",0.8)
    ocrConfig.save()
  },
  beginOCR:async function (button) {
  try {
    let foucsNote = ocrUtils.getFocusNote()
    let imageData = ocrUtils.getImageForOCR()
    if (!imageData) {
      MNUtil.showHUD("No image found")
      return
    }
    self.currentTime = Date.now()
    let res = await ocrNetwork.OCR(imageData)

    // MNUtil.copyJSON(res)
    if (res) {
      ocrUtils.showHUD("Time usage: "+(Date.now()-self.currentTime)+" ms")
      switch (button.action) {
        case "toComment":
          if (foucsNote) {
            ocrUtils.undoGrouping(()=>{
              foucsNote.appendMarkdownComment(res)
              MNUtil.showHUD("Append to comment")
            })
          }else{
            MNUtil.copy(res)
          }
          break;
        case "copy":
          MNUtil.copy(res)
          MNUtil.showHUD("Save to clipboard")
          break;
        case "toExcerpt":
          if (foucsNote) {
            ocrUtils.undoGrouping(()=>{
              foucsNote.textFirst = true
              foucsNote.markdown = true
              foucsNote.excerptText =  res
              MNUtil.showHUD("Set to excerpt")
            })
          }else{
            MNUtil.copy(res)
          }
          break;
        default:
          break;
      }

    }
      
    } catch (error) {
      MNUtil.showHUD(error)
      MNUtil.copy(error)
    }
  },
  beginPDFOCR:async function (button) {
  try {
    self.toExcerpt = false
    switch (button.mode) {
      case "copy":
        self.copy = true
        self.file = false
        self.export = false
        break;
      case "file":
        self.copy = false
        self.file = true
        self.export = false
        break;
      case "export":
        self.copy = false
        self.file = false
        self.export = true
        break;
      default:
        break;
    }
    let key
    self.docMd5 = MNUtil.currentDocController.document.docMd5
    let currentDocPath = MNUtil.currentDocController.document.fullPathFileName
    if (!currentDocPath) {
      MNUtil.showHUD("Doc not exist!")
      return
    }
    if (!MNUtil.isfileExists(currentDocPath)) {
      MNUtil.showHUD("Doc not exist!")
      return
    }
    let fileData = MNUtil.getFile(currentDocPath)
  
    if (!fileData) {
      return
    }
    key = ocrConfig.getConfig("doc2xApikey").trim()
    self.currentTime = Date.now()
    if (!key) {
      ocrUtils.showHUD("No doc2X API key")
      return
    }
    if (ocrConfig.fileIds[self.docMd5]) {
      MNUtil.showHUD("Get ocr result from doc2X")
      const headers = {
        Authorization: "Bearer "+key
      }
      let url = "https://api.doc2x.noedgeai.com/api/req/json/"+ocrConfig.fileIds[self.docMd5]
      let res = await ocrNetwork.fetch(url,{headers: headers})
      // MNUtil.copyJSON(res.data)
      if (self.export) {
        let docPath = MNUtil.cacheFolder+"/"+MNUtil.getFileName(MNUtil.getDocById(self.docMd5).fullPathFileName)+".md"
        MNUtil.writeText(docPath, res.data.pages.map(d=>d.md).join(""))
        let UTI = ["public.md"]
        MNUtil.saveFile(docPath, UTI)
        return
      }
      if (self.file) {
        MNUtil.writeJSON(MNUtil.dbFolder+"/"+self.docMd5+".json", res.data)
        MNUtil.showHUD("文件已保存到"+MNUtil.dbFolder)
        return
      }
      // MNUtil.copyJSON(self.res.pages)
      if (self.copy) {
        let mds = res.data.pages.map(page=>page.md)
        MNUtil.copy(mds.join(""))
        MNUtil.showHUD("Save to clipboard")
        return
      }
      return
    }
    ocrUtils.showHUD("PDF OCR By doc2X")
    let config = ocrConfig.config
    config.fileName = MNUtil.getFileName(MNUtil.currentDocController.document.fullPathFileName)
    let request = ocrNetwork.intDoc2xPDFOCRRequest(fileData)
    self.connection = NSURLConnection.connectionWithRequestDelegate(request,self)
      
    } catch (error) {
      ocrUtils.showHUD(error)
      ocrUtils.copy(error)
    }
  },
  connectionDidReceiveResponse: async function (connection,response) {
    self.textStirng = ""
  },
  /**
   * 
   * @param {NSURLConnection} connection 
   * @param {NSData} data 
   */
  connectionDidReceiveData: async function (connection,data) {
  // try {
  //   // let text =  NSString.initWithDataEncoding(data, 4)
  //   // MNUtil.copy(data.base64Encoding)
  //   let test = CryptoJS.enc.Base64.parse(data.base64Encoding())
  //   let textString = CryptoJS.enc.Utf8.stringify(test);
  //   self.textStirng = self.textStirng+textString
  //   let res = self.textStirng.split("data:").slice(1).map(r=>{
  //     return JSON.parse(r)
  //   })
  //   // MNUtil.copyJSON(self.textStirng)

  //   self.res = res.at(-1).data
  //   self.fileId = res.at(-1).uuid
  //   // self.res = ocrNetwork.parseDoc2XRespnse(data)
  //   // MNUtil.copyJSON(self.res)
  //   if (self.res.msg) {
  //     ocrUtils.showHUD(self.res.progress+"%|"+self.res.msg)
  //   }
  //   // ocrUtils.copyJSON(self.res)
  // } catch (error) {
  //   MNUtil.showHUD(error)
  //   MNUtil.copyJSON(error)
  // }

    // let test = CryptoJS.enc.Base64.parse(data.base64Encoding())
    // self.textString = CryptoJS.enc.Utf8.stringify(test);
    // let res = JSON.parse(self.textString.split("data:")[1])
  },
  connectionDidFinishLoading: function (connection) {
    // try {
    // if (ocrConfig.getConfig("source") === "Doc2XPDF") {
    //   ocrConfig.saveFileId(self.docMd5, self.fileId)
    //   if (self.export) {
    //     let docPath = MNUtil.cacheFolder+"/"+MNUtil.getFileName(MNUtil.getDocById(self.docMd5).fullPathFileName)+".md"
    //     MNUtil.writeText(docPath, self.res.pages.map(d=>d.md).join(""))
    //     let UTI = ["public.md"]
    //     MNUtil.saveFile(docPath, UTI)
    //     return
    //   }
    //   if (self.file) {
    //     MNUtil.writeJSON(MNUtil.dbFolder+"/"+self.docMd5+".json", self.res)
    //     MNUtil.showHUD("文件已保存到"+MNUtil.dbFolder)
    //     return
    //   }
    //   // MNUtil.copyJSON(self.res.pages)
    //   if (self.copy) {
    //     let mds = self.res.pages.map(page=>page.md)
    //     MNUtil.copy(mds.join(""))
    //     MNUtil.showHUD("Save to clipboard")
    //     return
    //   }
    //   return
    // }
    // let foucsNote = ocrUtils.getFocusNote()
    // // let regexp = new RegExp("(\[\\)|(\\\])", "g")
    // // MNUtil.copyJSON(self.res)
    // let md = self.res.pages[0].md
    // ocrUtils.showHUD("Time usage: "+(Date.now()-self.currentTime)+" ms")
    // if (self.copy) {
    //   ocrUtils.copy(md)
    //   ocrUtils.showHUD("Save to clipboard")
    //   return
    // }
    // let convertText = md
    // .replace(/(\\\[\s?)|(\s?\\\])/g, '$$') // Replace display math mode delimiters
    // .replace(/(\\\(\s?)|(\s?\\\))/g, '$') // Replace inline math mode opening delimiter
    // if (self.toExcerpt && foucsNote) {
    //   ocrUtils.undoGrouping(()=>{
    //     foucsNote.excerptText =  convertText
    //   })
    //   return
    // }
    // if (foucsNote) {
    //   ocrUtils.undoGrouping(()=>{
    //     foucsNote.appendMarkdownComment(convertText)
    //   })
    // }
    // } catch (error) {
    //   ocrUtils.showHUD(error)
    //   ocrUtils.copyJSON(self.res)
    // }
  },
  connectionDidFailWithError: function (connection,error) {
    ocrUtils.showHUD("network error")
  },
  changeOpacity: function(sender) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    let commandTable = [
      {title:'100%',object:self,selector:'changeOpacityTo:',param:1.0},
      {title:'90%',object:self,selector:'changeOpacityTo:',param:0.9},
      {title:'80%',object:self,selector:'changeOpacityTo:',param:0.8},
      {title:'70%',object:self,selector:'changeOpacityTo:',param:0.7},
      {title:'60%',object:self,selector:'changeOpacityTo:',param:0.6},
      {title:'50%',object:self,selector:'changeOpacityTo:',param:0.5}
    ];
    self.view.popoverController = ocrUtils.getPopoverAndPresent(sender,commandTable,100)

  },
  changeOpacityTo:function (opacity) {
    self.view.layer.opacity = opacity
  },
  closeButtonTapped: function() {
    self.hide(ocrUtils.addonBar.frame)
    },
  settingButtonTapped: function (params) {
    self.settingButton.open = !self.settingButton.open
    if (self.settingButton.open) {
      MNButton.setColor(self.settingButton, "#457bd3")
      self.settingView.hidden = false
      self.ocrView.hidden = true
    }else{
      MNButton.setColor(self.settingButton, "#89a6d5")
      self.settingView.hidden = true
      self.ocrView.hidden = false
    }
  },
  onMoveGesture:function (gesture) {

    let locationToMN = gesture.locationInView(ocrUtils.studyView)
    if ( (Date.now() - self.moveDate) > 100) {
      let translation = gesture.translationInView(ocrUtils.studyView)
      let locationToBrowser = gesture.locationInView(self.view)
      let locationToButton = gesture.locationInView(gesture.view)
      let buttonFrame = self.moveButton.frame
      let newY = locationToButton.y-translation.y 
      let newX = locationToButton.x-translation.x
      if (gesture.state !== 3 && (newY<buttonFrame.height+5 && newY>-5 && newX<buttonFrame.width+5 && newX>-5 && Math.abs(translation.y)<20 && Math.abs(translation.x)<20)) {
        gesture.locationToBrowser = {x:locationToBrowser.x-translation.x,y:locationToBrowser.y-translation.y}
      }
    }
    self.moveDate = Date.now()
    let location = {x:locationToMN.x - gesture.locationToBrowser.x,y:locationToMN.y -gesture.locationToBrowser.y}
    let frame = self.view.frame
    var viewFrame = self.view.bounds;
    let studyFrame = ocrUtils.studyView.bounds
    let y = location.y
    if (y<=0) {
      y = 0
    }
    if (y>=studyFrame.height-15) {
      y = studyFrame.height-15
    }
    let x = location.x
    ocrUtils.setFrame(self, {x:x,y:y,width:frame.width,height:frame.height})
  }
});
ocrController.prototype.setButtonLayout = function (button,targetAction) {
    button.autoresizingMask = (1 << 0 | 1 << 3);
    button.setTitleColorForState(UIColor.whiteColor(),0);
    button.setTitleColorForState(this.highlightColor, 1);
    button.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
    button.layer.cornerRadius = 10;
    button.layer.masksToBounds = true;
    if (targetAction) {
      button.addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    this.view.addSubview(button);
}
/**
 * @this {ocrController}
 */
ocrController.prototype.show = function (frame) {
  let preFrame = this.view.frame
  preFrame.width = 260
  let preOpacity = this.view.layer.opacity
  this.view.layer.opacity = 0.2
  if (frame) {
    this.view.frame = frame
    this.currentFrame = frame
  }
  this.view.hidden = false
  this.setAllButton(true)
  this.ocrView.hidden = true
  this.settingView.hidden = true
  ocrUtils.studyView.bringSubviewToFront(this.view)
  UIView.animateWithDurationAnimationsCompletion(0.2,()=>{
    this.view.layer.opacity = preOpacity
    this.view.frame = preFrame
    this.currentFrame = preFrame
  },
  ()=>{
    this.view.layer.borderWidth = 0
    this.setAllButton(false)
    this.ocrView.hidden = false
    this.settingView.hidden = true
    MNButton.setColor(this.settingButton, "#89a6d5")
    this.settingButton.open = false
    this.refreshView(ocrConfig.config.source)
  })
}
ocrController.prototype.setAllButton = function (hidden) {
  this.moveButton.hidden = hidden
  this.closeButton.hidden = hidden
  this.settingButton.hidden = hidden
  // this.OCRButton.hidden = hidden
  // this.OCRExcerptButton.hidden = hidden
  // this.apikeyInput.hidden = hidden
  // this.pasteKeyButton.hidden = hidden
  // this.clearButton.hidden = hidden
  // switch (ocrConfig.getConfig("source")) {
  //   case "Doc2X":
  //     this.imageCorrectionButton.hidden = hidden
  //     this.equationButton.hidden = hidden
  //     this.rotationButton.hidden = true
  //     this.PDFOCRButton.hidden = true
  //     this.PDFOCRExportButton.hidden = true
  //     this.PDFOCRFileButton.hidden = true
  //     this.PDFOCRCopyButton.hidden = true
  //     this.OCRCopyButton.hidden = hidden
  //     this.OCRButton.hidden = hidden
  //     this.OCRExcerptButton.hidden = hidden
  //     break;
  //   case "SimpleTex":
  //     this.rotationButton.hidden = hidden
  //     this.imageCorrectionButton.hidden = hidden
  //     this.equationButton.hidden = hidden
  //     this.PDFOCRButton.hidden = true
  //     this.PDFOCRExportButton.hidden = true
  //     this.PDFOCRFileButton.hidden = true
  //     this.PDFOCRCopyButton.hidden = true
  //     this.OCRButton.hidden = hidden
  //     this.OCRCopyButton.hidden = hidden
  //     this.OCRExcerptButton.hidden = hidden
  //     break;
  //   case "Doc2XPDF":
  //     this.rotationButton.hidden = true
  //     this.imageCorrectionButton.hidden = true
  //     this.equationButton.hidden = true
  //     this.PDFOCRButton.hidden = hidden
  //     this.OCRExcerptButton.hidden = true
  //     this.OCRButton.hidden = true
  //     this.PDFOCRCopyButton.hidden = hidden
  //     this.PDFOCRExportButton.hidden = hidden
  //     this.OCRCopyButton.hidden = true
  //     this.PDFOCRFileButton.hidden = hidden
  //     break;
  //   default:
  //     break;
  // }
}
ocrController.prototype.hide = function (frame) {
  let preFrame = this.view.frame
  preFrame.width = 260
  this.view.frame = preFrame
  let preOpacity = this.view.layer.opacity
        // Application.sharedInstance().showHUD(JSON.stringify(frame),this.view.window,2)
  this.setAllButton(true)
  this.ocrView.hidden = true
  this.settingView.hidden = true
  UIView.animateWithDurationAnimationsCompletion(0.25,()=>{
    this.view.layer.opacity = 0.2
    if (frame) {
      this.view.frame = frame
      this.currentFrame = frame
    }
  },
  ()=>{
    this.view.hidden = true;
    this.view.layer.opacity = preOpacity      
    this.view.frame = preFrame
    this.currentFrame = preFrame

  })
}

/**
 * @this {ocrController}
 * @returns {UITextView}
 */
ocrController.prototype.creatTextView = function (superview="view",color="#c0bfbf",alpha=0.9) {
  /** @type {UITextView} */
  let view = UITextView.new()
  view.font = UIFont.systemFontOfSize(15);
  view.layer.cornerRadius = 8
  view.backgroundColor = ocrUtils.hexColorAlpha(color,alpha)
  view.textColor = UIColor.blackColor()
  view.delegate = this
  view.bounces = true
  this[superview].addSubview(view)
  return view
}
/**
 * @this {ocrController}
 */
ocrController.prototype.refreshView = function (source){
  switch (source) {
    case "Doc2X":
      this.moveButton.setTitleForState("Doc2X Image")
      this.apikeyInput.text = ocrConfig.getConfig("doc2xApikey")
      this.imageCorrectionButton.hidden = false
      this.imageCorrectionButton.setTitleForState("Image Correction: "+(ocrConfig.getConfig("imageCorrection")?"✅":"❌"),0)
      this.imageCorrectionButton.backgroundColor = ocrUtils.hexColorAlpha(ocrConfig.getConfig("imageCorrection")?"#457bd3":"#9bb2d6",0.8)
      this.equationButton.hidden = false
      this.equationButton.setTitleForState("Pure Equation: "+(ocrConfig.getConfig("pureEquation")?"✅":"❌"),0)
      this.equationButton.backgroundColor = ocrUtils.hexColorAlpha(ocrConfig.getConfig("pureEquation")?"#457bd3":"#9bb2d6",0.8)
      this.PDFOCRButton.hidden = true
      this.rotationButton.hidden = true
      this.PDFOCRExportButton.hidden = true
      this.PDFOCRFileButton.hidden = true
      this.PDFOCRCopyButton.hidden = true
      this.OCRButton.hidden = false
      this.OCRExcerptButton.hidden = false
      this.OCRCopyButton.hidden = false
      this.refreshButton.hidden = false
      break;
    case "Doc2XPDF":
      this.moveButton.setTitleForState("Doc2X PDF")
      this.apikeyInput.text = ocrConfig.getConfig("doc2xApikey")
      this.imageCorrectionButton.hidden = true
      this.equationButton.hidden = true
      this.PDFOCRButton.hidden = false
      this.PDFOCRExportButton.hidden = false
      this.PDFOCRFileButton.hidden = false
      this.PDFOCRCopyButton.hidden = false
      this.PDFOCRButton.setTitleForState("PDF OCR: "+(ocrConfig.getConfig("PDFOCR")?"✅":"❌"),0)
      this.PDFOCRButton.backgroundColor = MNUtil.hexColorAlpha(ocrConfig.getConfig("PDFOCR")?"#457bd3":"#9bb2d6",0.8)
      this.OCRCopyButton.hidden = true
      this.rotationButton.hidden = true
      this.OCRButton.hidden = true
      this.OCRExcerptButton.hidden = true
      this.refreshButton.hidden = false
      break;
    case "SimpleTex":
      this.moveButton.setTitleForState("SimpleTex Image")
      this.apikeyInput.text = ocrConfig.getConfig("simpleTexApikey")
      this.rotationButton.hidden = false
      this.rotationButton.setTitleForState("Image Ratation: "+(ocrConfig.getConfig("simpleTexRotation")?"✅":"❌"),0)
      this.rotationButton.backgroundColor = ocrUtils.hexColorAlpha(ocrConfig.config.simpleTexRotation?"#457bd3":"#9bb2d6",0.8)
      this.imageCorrectionButton.hidden = true
      this.PDFOCRButton.hidden = true
      this.equationButton.hidden = false
      this.equationButton.setTitleForState("Rec mode: "+ocrConfig.getConfig("simpleTexRecMode"),0)
      this.equationButton.backgroundColor = ocrUtils.hexColorAlpha(ocrConfig.getConfig("simpleTexGeneral")?"#9bb2d6":"#457bd3",0.8)

      this.PDFOCRExportButton.hidden = true
      this.PDFOCRFileButton.hidden = true
      this.PDFOCRCopyButton.hidden = true
      this.OCRButton.hidden = false
      this.OCRCopyButton.hidden = false
      this.OCRExcerptButton.hidden = false
      this.refreshButton.hidden = true
      break;
    default:
      break;
  }
}

ocrController.prototype.createView = function (superview="view",color="#9bb2d6",alpha=0.8) {
  let view = UIView.new()
  view.backgroundColor = MNUtil.hexColorAlpha(color,alpha)
  view.layer.cornerRadius = 12
  this[superview].addSubview(view)
  return view
}

ocrController.prototype.createButton = function (targetAction,superview) {
    let button = UIButton.buttonWithType(0);
    button.autoresizingMask = (1 << 0 | 1 << 3);
    button.setTitleColorForState(UIColor.whiteColor(),0);
    button.setTitleColorForState(this.highlightColor, 1);
    button.backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
    button.layer.cornerRadius = 8;
    button.layer.masksToBounds = true;
    button.titleLabel.font = UIFont.systemFontOfSize(16);

    if (targetAction) {
      button.addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    if (superview) {
      this[superview].addSubview(button)
    }else{
      this.view.addSubview(button);
    }
    return button
}

// ocrController.prototype.createButton = function (config) {
//   let button = UIButton.buttonWithType(0);
//   button.autoresizingMask = (1 << 0 | 1 << 3);
//   button.setTitleColorForState(this.highlightColor, 1);
//   if ("fontColor" in config) {
//     button.setTitleColorForState(MNUtil.hexColorAlpha(config.fontColor),0);
//   }else{
//     button.setTitleColorForState(UIColor.whiteColor(),0);
//   }
//   if ("targetAction" in config) {
//     button.addTargetActionForControlEvents(this, config.targetAction, 1 << 6);
//   }
//   if ("superView" in config) {
//     this[config.superView].addSubview(button)
//   }else{
//     this.view.addSubview(button);
//   }
//   if ("color" in config) {
    
//   }
//   MNButton.setConfig(button, config)
//     button.backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
//     button.layer.cornerRadius = 8;
//     button.layer.masksToBounds = true;
//     button.titleLabel.font = UIFont.systemFontOfSize(16);
//     return button
// }